package gregapi.cover.covers;

import static gregapi.data.CS.F;
import static gregapi.data.CS.T;
import gregapi.cover.CoverData;
import gregapi.cover.ICover;
import gregapi.data.CS.SFX;
import gregapi.data.LH;
import gregapi.render.ITexture;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 * 
 * A Default implementations that is used for all regular Covers.
 */
public abstract class AbstractCoverDefault implements ICover {
	@Override public boolean interceptCoverPlacement(byte aSide, CoverData aData, Entity aPlayer) {return F;}
	@Override public boolean interceptCoverRemoval(byte aSide, CoverData aData, Entity aPlayer) {return F;}
	@Override public void onCoverPlaced(byte aSide, CoverData aData, Entity aPlayer, ItemStack aCover) {if (aPlayer != null) UT.Sounds.send(aData.mTileEntity.getWorld(), SFX.IC_WRENCH, 1.0F, -1.0F, aData.mTileEntity.getCoords());}
	@Override public void onTickPre (byte aSide, CoverData aData, long aTimer, boolean aIsServerSide) {/**/}
	@Override public void onTickPost(byte aSide, CoverData aData, long aTimer, boolean aIsServerSide) {/**/}
	@Override public boolean onCoverClickedLeft (byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return F;}
	@Override public boolean interceptClickLeft (byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return T;}
	@Override public boolean onCoverClickedRight(byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return F;}
	@Override public boolean interceptClickRight(byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return T;}
	@Override public long onToolClick(byte aSide, CoverData aData, String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, List<String> aChatReturn, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return 0;}
	@Override public ItemStack getCoverItem(byte aSide, CoverData aData) {return UT.Stacks.make(aData.mIDs[aSide], 1, aData.mMetas[aSide], aData.mNBTs[aSide]==null||aData.mNBTs[aSide].hasNoTags()?null:aData.mNBTs[aSide]);}
	@Override public ITexture getCoverTextureSurface(byte aSide, CoverData aData) {return null;}
	@Override public ITexture getCoverTextureAttachment(byte aSide, CoverData aData, byte aTextureSide) {return getCoverTextureSurface(aSide, aData);}
	@Override public ITexture getCoverTextureHolder(byte aSide, CoverData aData, byte aTextureSide) {return getCoverTextureSurface(aSide, aData);}
	@Override public boolean isSolid(byte aSide, CoverData aData) {return T;}
	@Override public boolean isOpaque(byte aSide, CoverData aData) {return T;}
	@Override public boolean needsVisualsSaved(byte aSide, CoverData aData) {return F;}
	@Override public Object getGUIServer(byte aSide, CoverData aData, EntityPlayer aPlayer) {return null;}
	@Override public Object getGUIClient(byte aSide, CoverData aData, EntityPlayer aPlayer) {return null;}
	@Override public void addToolTips(List aList, ItemStack aStack, boolean aF3_H) {aList.add(LH.get(LH.COVER_TOOLTIP));}
}